diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/lte/model/lte-ue-rrc.cc ns-3.33/src/lte/model/lte-ue-rrc.cc
--- ns-3.32/src/lte/model/lte-ue-rrc.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/lte/model/lte-ue-rrc.cc	2021-01-09 10:19:22.000000000 -0800
@@ -1903,445 +1898,328 @@
 
   switch (reportConfigEutra.eventId)
     {
-    case LteRrcSap::ReportConfigEutra::EVENT_A1:
-      {
-        /*
-         * Event A1 (Serving becomes better than threshold)
-         * Please refer to 3GPP TS 36.331 Section 5.5.4.2
-         */
-
-        double ms; // Ms, the measurement result of the serving cell
-        double thresh; // Thresh, the threshold parameter for this event
-        // Hys, the hysteresis parameter for this event.
-        double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
-
-        switch (reportConfigEutra.triggerQuantity)
-          {
-          case LteRrcSap::ReportConfigEutra::RSRP:
-            ms = m_storedMeasValues[m_cellId].rsrp;
-            NS_ASSERT (reportConfigEutra.threshold1.choice
-                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
-            thresh = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
-            break;
-          case LteRrcSap::ReportConfigEutra::RSRQ:
-            ms = m_storedMeasValues[m_cellId].rsrq;
-            NS_ASSERT (reportConfigEutra.threshold1.choice
-                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
-            thresh = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
-            break;
-          default:
-            NS_FATAL_ERROR ("unsupported triggerQuantity");
-            break;
-          }
-
-        // Inequality A1-1 (Entering condition): Ms - Hys > Thresh
-        bool entryCond = ms - hys > thresh;
-
-        if (entryCond)
-          {
-            if (!isMeasIdInReportList)
-              {
-                concernedCellsEntry.push_back (m_cellId);
-                eventEntryCondApplicable = true;
-              }
-            else
-              {
-                /*
-                 * This is to check that the triggered cell recorded in the
-                 * VarMeasReportList is the serving cell.
-                 */
-                NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
-                           != measReportIt->second.cellsTriggeredList.end ());
-              }
-          }
-        else if (reportConfigEutra.timeToTrigger > 0)
-          {
-            CancelEnteringTrigger (measId);
-          }
+      case LteRrcSap::ReportConfigEutra::EVENT_A1:
+        {
+          /*
+           * Event A1 (Serving becomes better than threshold)
+           * Please refer to 3GPP TS 36.331 Section 5.5.4.2
+           */
 
-        // Inequality A1-2 (Leaving condition): Ms + Hys < Thresh
-        bool leavingCond = ms + hys < thresh;
+          double ms; // Ms, the measurement result of the serving cell
+          double thresh; // Thresh, the threshold parameter for this event
+          // Hys, the hysteresis parameter for this event.
+          double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
 
-        if (leavingCond)
-          {
-            if (isMeasIdInReportList)
-              {
-                /*
-                 * This is to check that the triggered cell recorded in the
-                 * VarMeasReportList is the serving cell.
-                 */
-                NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
-                           != measReportIt->second.cellsTriggeredList.end ());
-                concernedCellsLeaving.push_back (m_cellId);
-                eventLeavingCondApplicable = true;
-              }
-          }
-        else if (reportConfigEutra.timeToTrigger > 0)
-          {
-            CancelLeavingTrigger (measId);
-          }
+          switch (reportConfigEutra.triggerQuantity)
+            {
+              case LteRrcSap::ReportConfigEutra::RSRP:
+                ms = m_storedMeasValues[m_cellId].rsrp;
+                NS_ASSERT (reportConfigEutra.threshold1.choice
+                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
+                thresh = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
+                break;
+              case LteRrcSap::ReportConfigEutra::RSRQ:
+                ms = m_storedMeasValues[m_cellId].rsrq;
+                NS_ASSERT (reportConfigEutra.threshold1.choice
+                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
+                thresh = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
+                break;
+              default:
+                NS_FATAL_ERROR ("unsupported triggerQuantity");
+                break;
+            }
 
-        NS_LOG_LOGIC (this << " event A1: serving cell " << m_cellId
-                           << " ms=" << ms << " thresh=" << thresh
-                           << " entryCond=" << entryCond
-                           << " leavingCond=" << leavingCond);
-
-      } // end of case LteRrcSap::ReportConfigEutra::EVENT_A1
-
-      break;
-
-    case LteRrcSap::ReportConfigEutra::EVENT_A2:
-      {
-        /*
-         * Event A2 (Serving becomes worse than threshold)
-         * Please refer to 3GPP TS 36.331 Section 5.5.4.3
-         */
-
-        double ms; // Ms, the measurement result of the serving cell
-        double thresh; // Thresh, the threshold parameter for this event
-        // Hys, the hysteresis parameter for this event.
-        double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
+          // Inequality A1-1 (Entering condition): Ms - Hys > Thresh
+          bool entryCond = ms - hys > thresh;
 
-        switch (reportConfigEutra.triggerQuantity)
-          {
-          case LteRrcSap::ReportConfigEutra::RSRP:
-            ms = m_storedMeasValues[m_cellId].rsrp;
-            NS_ASSERT (reportConfigEutra.threshold1.choice
-                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
-            thresh = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
-            break;
-          case LteRrcSap::ReportConfigEutra::RSRQ:
-            ms = m_storedMeasValues[m_cellId].rsrq;
-            NS_ASSERT (reportConfigEutra.threshold1.choice
-                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
-            thresh = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
-            break;
-          default:
-            NS_FATAL_ERROR ("unsupported triggerQuantity");
-            break;
-          }
+          if (entryCond)
+            {
+              if (!isMeasIdInReportList)
+                {
+                  concernedCellsEntry.push_back (m_cellId);
+                  eventEntryCondApplicable = true;
+                }
+              else
+                {
+                  /*
+                   * This is to check that the triggered cell recorded in the
+                   * VarMeasReportList is the serving cell.
+                   */
+                  NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
+                             != measReportIt->second.cellsTriggeredList.end ());
+                }
+            }
+          else if (reportConfigEutra.timeToTrigger > 0)
+            {
+              CancelEnteringTrigger (measId);
+            }
 
-        // Inequality A2-1 (Entering condition): Ms + Hys < Thresh
-        bool entryCond = ms + hys < thresh;
+          // Inequality A1-2 (Leaving condition): Ms + Hys < Thresh
+          bool leavingCond = ms + hys < thresh;
 
-        if (entryCond)
-          {
-            if (!isMeasIdInReportList)
-              {
-                concernedCellsEntry.push_back (m_cellId);
-                eventEntryCondApplicable = true;
-              }
-            else
-              {
-                /*
-                 * This is to check that the triggered cell recorded in the
-                 * VarMeasReportList is the serving cell.
-                 */
-                NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
-                           != measReportIt->second.cellsTriggeredList.end ());
-              }
-          }
-        else if (reportConfigEutra.timeToTrigger > 0)
-          {
-            CancelEnteringTrigger (measId);
-          }
+          if (leavingCond)
+            {
+              if (isMeasIdInReportList)
+                {
+                  /*
+                   * This is to check that the triggered cell recorded in the
+                   * VarMeasReportList is the serving cell.
+                   */
+                  NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
+                             != measReportIt->second.cellsTriggeredList.end ());
+                  concernedCellsLeaving.push_back (m_cellId);
+                  eventLeavingCondApplicable = true;
+                }
+            }
+          else if (reportConfigEutra.timeToTrigger > 0)
+            {
+              CancelLeavingTrigger (measId);
+            }
 
-        // Inequality A2-2 (Leaving condition): Ms - Hys > Thresh
-        bool leavingCond = ms - hys > thresh;
+          NS_LOG_LOGIC (this << " event A1: serving cell " << m_cellId
+                             << " ms=" << ms << " thresh=" << thresh
+                             << " entryCond=" << entryCond
+                             << " leavingCond=" << leavingCond);
 
-        if (leavingCond)
-          {
-            if (isMeasIdInReportList)
-              {
-                /*
-                 * This is to check that the triggered cell recorded in the
-                 * VarMeasReportList is the serving cell.
-                 */
-                NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
-                           != measReportIt->second.cellsTriggeredList.end ());
-                concernedCellsLeaving.push_back (m_cellId);
-                eventLeavingCondApplicable = true;
-              }
-          }
-        else if (reportConfigEutra.timeToTrigger > 0)
-          {
-            CancelLeavingTrigger (measId);
-          }
+        } // end of case LteRrcSap::ReportConfigEutra::EVENT_A1
 
-        NS_LOG_LOGIC (this << " event A2: serving cell " << m_cellId
-                           << " ms=" << ms << " thresh=" << thresh
-                           << " entryCond=" << entryCond
-                           << " leavingCond=" << leavingCond);
-
-      } // end of case LteRrcSap::ReportConfigEutra::EVENT_A2
-
-      break;
-
-    case LteRrcSap::ReportConfigEutra::EVENT_A3:
-      {
-        /*
-         * Event A3 (Neighbour becomes offset better than PCell)
-         * Please refer to 3GPP TS 36.331 Section 5.5.4.4
-         */
-
-        double mn; // Mn, the measurement result of the neighbouring cell
-        double ofn = measObjectEutra.offsetFreq; // Ofn, the frequency specific offset of the frequency of the
-        double ocn = 0.0; // Ocn, the cell specific offset of the neighbour cell
-        double mp; // Mp, the measurement result of the PCell
-        double ofp = measObjectEutra.offsetFreq; // Ofp, the frequency specific offset of the primary frequency
-        double ocp = 0.0; // Ocp, the cell specific offset of the PCell
-        // Off, the offset parameter for this event.
-        double off = EutranMeasurementMapping::IeValue2ActualA3Offset (reportConfigEutra.a3Offset);
-        // Hys, the hysteresis parameter for this event.
-        double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
+        break;
 
-        switch (reportConfigEutra.triggerQuantity)
-          {
-          case LteRrcSap::ReportConfigEutra::RSRP:
-            mp = m_storedMeasValues[m_cellId].rsrp;
-            NS_ASSERT (reportConfigEutra.threshold1.choice
-                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
-            break;
-          case LteRrcSap::ReportConfigEutra::RSRQ:
-            mp = m_storedMeasValues[m_cellId].rsrq;
-            NS_ASSERT (reportConfigEutra.threshold1.choice
-                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
-            break;
-          default:
-            NS_FATAL_ERROR ("unsupported triggerQuantity");
-            break;
-          }
+      case LteRrcSap::ReportConfigEutra::EVENT_A2:
+        {
+          /*
+           * Event A2 (Serving becomes worse than threshold)
+           * Please refer to 3GPP TS 36.331 Section 5.5.4.3
+           */
 
-        for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
-             storedMeasIt != m_storedMeasValues.end ();
-             ++storedMeasIt)
-          {
-            uint16_t cellId = storedMeasIt->first;
-            if (cellId == m_cellId)
-              {
-                continue;
-              }
+          double ms; // Ms, the measurement result of the serving cell
+          double thresh; // Thresh, the threshold parameter for this event
+          // Hys, the hysteresis parameter for this event.
+          double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
 
-            switch (reportConfigEutra.triggerQuantity)
-              {
+          switch (reportConfigEutra.triggerQuantity)
+            {
               case LteRrcSap::ReportConfigEutra::RSRP:
-                mn = storedMeasIt->second.rsrp;
+                ms = m_storedMeasValues[m_cellId].rsrp;
+                NS_ASSERT (reportConfigEutra.threshold1.choice
+                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
+                thresh = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
                 break;
               case LteRrcSap::ReportConfigEutra::RSRQ:
-                mn = storedMeasIt->second.rsrq;
+                ms = m_storedMeasValues[m_cellId].rsrq;
+                NS_ASSERT (reportConfigEutra.threshold1.choice
+                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
+                thresh = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
                 break;
               default:
                 NS_FATAL_ERROR ("unsupported triggerQuantity");
                 break;
-              }
+            }
 
-            bool hasTriggered = isMeasIdInReportList
-              && (measReportIt->second.cellsTriggeredList.find (cellId)
-                  != measReportIt->second.cellsTriggeredList.end ());
+          // Inequality A2-1 (Entering condition): Ms + Hys < Thresh
+          bool entryCond = ms + hys < thresh;
 
-            // Inequality A3-1 (Entering condition): Mn + Ofn + Ocn - Hys > Mp + Ofp + Ocp + Off
-            bool entryCond = mn + ofn + ocn - hys > mp + ofp + ocp + off;
+          if (entryCond)
+            {
+              if (!isMeasIdInReportList)
+                {
+                  concernedCellsEntry.push_back (m_cellId);
+                  eventEntryCondApplicable = true;
+                }
+              else
+                {
+                  /*
+                   * This is to check that the triggered cell recorded in the
+                   * VarMeasReportList is the serving cell.
+                   */
+                  NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
+                             != measReportIt->second.cellsTriggeredList.end ());
+                }
+            }
+          else if (reportConfigEutra.timeToTrigger > 0)
+            {
+              CancelEnteringTrigger (measId);
+            }
 
-            if (entryCond)
-              {
-                if (!hasTriggered)
-                  {
-                    concernedCellsEntry.push_back (cellId);
-                    eventEntryCondApplicable = true;
-                  }
-              }
-            else if (reportConfigEutra.timeToTrigger > 0)
-              {
-                CancelEnteringTrigger (measId, cellId);
-              }
+          // Inequality A2-2 (Leaving condition): Ms - Hys > Thresh
+          bool leavingCond = ms - hys > thresh;
 
-            // Inequality A3-2 (Leaving condition): Mn + Ofn + Ocn + Hys < Mp + Ofp + Ocp + Off
-            bool leavingCond = mn + ofn + ocn + hys < mp + ofp + ocp + off;
+          if (leavingCond)
+            {
+              if (isMeasIdInReportList)
+                {
+                  /*
+                   * This is to check that the triggered cell recorded in the
+                   * VarMeasReportList is the serving cell.
+                   */
+                  NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
+                             != measReportIt->second.cellsTriggeredList.end ());
+                  concernedCellsLeaving.push_back (m_cellId);
+                  eventLeavingCondApplicable = true;
+                }
+            }
+          else if (reportConfigEutra.timeToTrigger > 0)
+            {
+              CancelLeavingTrigger (measId);
+            }
 
-            if (leavingCond)
-              {
-                if (hasTriggered)
-                  {
-                    concernedCellsLeaving.push_back (cellId);
-                    eventLeavingCondApplicable = true;
-                  }
-              }
-            else if (reportConfigEutra.timeToTrigger > 0)
-              {
-                CancelLeavingTrigger (measId, cellId);
-              }
+          NS_LOG_LOGIC (this << " event A2: serving cell " << m_cellId
+                             << " ms=" << ms << " thresh=" << thresh
+                             << " entryCond=" << entryCond
+                             << " leavingCond=" << leavingCond);
 
-            NS_LOG_LOGIC (this << " event A3: neighbor cell " << cellId
-                               << " mn=" << mn << " mp=" << mp << " offset=" << off
-                               << " entryCond=" << entryCond
-                               << " leavingCond=" << leavingCond);
-
-          } // end of for (storedMeasIt)
-
-      } // end of case LteRrcSap::ReportConfigEutra::EVENT_A3
-
-      break;
-
-    case LteRrcSap::ReportConfigEutra::EVENT_A4:
-      {
-        /*
-         * Event A4 (Neighbour becomes better than threshold)
-         * Please refer to 3GPP TS 36.331 Section 5.5.4.5
-         */
-
-        double mn; // Mn, the measurement result of the neighbouring cell
-        double ofn = measObjectEutra.offsetFreq; // Ofn, the frequency specific offset of the frequency of the
-        double ocn = 0.0; // Ocn, the cell specific offset of the neighbour cell
-        double thresh; // Thresh, the threshold parameter for this event
-        // Hys, the hysteresis parameter for this event.
-        double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
+        } // end of case LteRrcSap::ReportConfigEutra::EVENT_A2
 
-        switch (reportConfigEutra.triggerQuantity)
-          {
-          case LteRrcSap::ReportConfigEutra::RSRP:
-            NS_ASSERT (reportConfigEutra.threshold1.choice
-                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
-            thresh = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
-            break;
-          case LteRrcSap::ReportConfigEutra::RSRQ:
-            NS_ASSERT (reportConfigEutra.threshold1.choice
-                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
-            thresh = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
-            break;
-          default:
-            NS_FATAL_ERROR ("unsupported triggerQuantity");
-            break;
-          }
+        break;
 
-        for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
-             storedMeasIt != m_storedMeasValues.end ();
-             ++storedMeasIt)
-          {
-            uint16_t cellId = storedMeasIt->first;
-            if (cellId == m_cellId)
-              {
-                continue;
-              }
+      case LteRrcSap::ReportConfigEutra::EVENT_A3:
+        {
+          /*
+           * Event A3 (Neighbour becomes offset better than PCell)
+           * Please refer to 3GPP TS 36.331 Section 5.5.4.4
+           */
 
-            switch (reportConfigEutra.triggerQuantity)
-              {
+          double mn; // Mn, the measurement result of the neighbouring cell
+          double ofn = measObjectEutra.offsetFreq; // Ofn, the frequency specific offset of the frequency of the
+          double ocn = 0.0; // Ocn, the cell specific offset of the neighbour cell
+          double mp; // Mp, the measurement result of the PCell
+          double ofp = measObjectEutra.offsetFreq; // Ofp, the frequency specific offset of the primary frequency
+          double ocp = 0.0; // Ocp, the cell specific offset of the PCell
+          // Off, the offset parameter for this event.
+          double off = EutranMeasurementMapping::IeValue2ActualA3Offset (reportConfigEutra.a3Offset);
+          // Hys, the hysteresis parameter for this event.
+          double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
+
+          switch (reportConfigEutra.triggerQuantity)
+            {
               case LteRrcSap::ReportConfigEutra::RSRP:
-                mn = storedMeasIt->second.rsrp;
+                mp = m_storedMeasValues[m_cellId].rsrp;
+                NS_ASSERT (reportConfigEutra.threshold1.choice
+                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
                 break;
               case LteRrcSap::ReportConfigEutra::RSRQ:
-                mn = storedMeasIt->second.rsrq;
+                mp = m_storedMeasValues[m_cellId].rsrq;
+                NS_ASSERT (reportConfigEutra.threshold1.choice
+                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
                 break;
               default:
                 NS_FATAL_ERROR ("unsupported triggerQuantity");
                 break;
-              }
+            }
 
-            bool hasTriggered = isMeasIdInReportList
-              && (measReportIt->second.cellsTriggeredList.find (cellId)
-                  != measReportIt->second.cellsTriggeredList.end ());
+          for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
+               storedMeasIt != m_storedMeasValues.end ();
+               ++storedMeasIt)
+            {
+              uint16_t cellId = storedMeasIt->first;
+              if (cellId == m_cellId)
+                {
+                  continue;
+                }
 
-            // Inequality A4-1 (Entering condition): Mn + Ofn + Ocn - Hys > Thresh
-            bool entryCond = mn + ofn + ocn - hys > thresh;
+              switch (reportConfigEutra.triggerQuantity)
+                {
+                  case LteRrcSap::ReportConfigEutra::RSRP:
+                    mn = storedMeasIt->second.rsrp;
+                    break;
+                  case LteRrcSap::ReportConfigEutra::RSRQ:
+                    mn = storedMeasIt->second.rsrq;
+                    break;
+                  default:
+                    NS_FATAL_ERROR ("unsupported triggerQuantity");
+                    break;
+                }
 
-            if (entryCond)
-              {
-                if (!hasTriggered)
-                  {
-                    concernedCellsEntry.push_back (cellId);
-                    eventEntryCondApplicable = true;
-                  }
-              }
-            else if (reportConfigEutra.timeToTrigger > 0)
-              {
-                CancelEnteringTrigger (measId, cellId);
-              }
+              bool hasTriggered = isMeasIdInReportList
+                && (measReportIt->second.cellsTriggeredList.find (cellId)
+                    != measReportIt->second.cellsTriggeredList.end ());
 
-            // Inequality A4-2 (Leaving condition): Mn + Ofn + Ocn + Hys < Thresh
-            bool leavingCond = mn + ofn + ocn + hys < thresh;
+              // Inequality A3-1 (Entering condition): Mn + Ofn + Ocn - Hys > Mp + Ofp + Ocp + Off
+              bool entryCond = mn + ofn + ocn - hys > mp + ofp + ocp + off;
 
-            if (leavingCond)
-              {
-                if (hasTriggered)
-                  {
-                    concernedCellsLeaving.push_back (cellId);
-                    eventLeavingCondApplicable = true;
-                  }
-              }
-            else if (reportConfigEutra.timeToTrigger > 0)
-              {
-                CancelLeavingTrigger (measId, cellId);
-              }
+              if (entryCond)
+                {
+                  if (!hasTriggered)
+                    {
+                      concernedCellsEntry.push_back (cellId);
+                      eventEntryCondApplicable = true;
+                    }
+                }
+              else if (reportConfigEutra.timeToTrigger > 0)
+                {
+                  CancelEnteringTrigger (measId, cellId);
+                }
 
-            NS_LOG_LOGIC (this << " event A4: neighbor cell " << cellId
-                               << " mn=" << mn << " thresh=" << thresh
-                               << " entryCond=" << entryCond
-                               << " leavingCond=" << leavingCond);
-
-          } // end of for (storedMeasIt)
-
-      } // end of case LteRrcSap::ReportConfigEutra::EVENT_A4
-
-      break;
-
-    case LteRrcSap::ReportConfigEutra::EVENT_A5:
-      {
-        /*
-         * Event A5 (PCell becomes worse than threshold1 and neighbour
-         * becomes better than threshold2)
-         * Please refer to 3GPP TS 36.331 Section 5.5.4.6
-         */
-
-        double mp; // Mp, the measurement result of the PCell
-        double mn; // Mn, the measurement result of the neighbouring cell
-        double ofn = measObjectEutra.offsetFreq; // Ofn, the frequency specific offset of the frequency of the
-        double ocn = 0.0; // Ocn, the cell specific offset of the neighbour cell
-        double thresh1; // Thresh1, the threshold parameter for this event
-        double thresh2; // Thresh2, the threshold parameter for this event
-        // Hys, the hysteresis parameter for this event.
-        double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
+              // Inequality A3-2 (Leaving condition): Mn + Ofn + Ocn + Hys < Mp + Ofp + Ocp + Off
+              bool leavingCond = mn + ofn + ocn + hys < mp + ofp + ocp + off;
 
-        switch (reportConfigEutra.triggerQuantity)
-          {
-          case LteRrcSap::ReportConfigEutra::RSRP:
-            mp = m_storedMeasValues[m_cellId].rsrp;
-            NS_ASSERT (reportConfigEutra.threshold1.choice
-                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
-            NS_ASSERT (reportConfigEutra.threshold2.choice
-                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
-            thresh1 = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
-            thresh2 = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold2.range);
-            break;
-          case LteRrcSap::ReportConfigEutra::RSRQ:
-            mp = m_storedMeasValues[m_cellId].rsrq;
-            NS_ASSERT (reportConfigEutra.threshold1.choice
-                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
-            NS_ASSERT (reportConfigEutra.threshold2.choice
-                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
-            thresh1 = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
-            thresh2 = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold2.range);
-            break;
-          default:
-            NS_FATAL_ERROR ("unsupported triggerQuantity");
-            break;
-          }
+              if (leavingCond)
+                {
+                  if (hasTriggered)
+                    {
+                      concernedCellsLeaving.push_back (cellId);
+                      eventLeavingCondApplicable = true;
+                    }
+                }
+              else if (reportConfigEutra.timeToTrigger > 0)
+                {
+                  CancelLeavingTrigger (measId, cellId);
+                }
 
-        // Inequality A5-1 (Entering condition 1): Mp + Hys < Thresh1
-        bool entryCond = mp + hys < thresh1;
+              NS_LOG_LOGIC (this << " event A3: neighbor cell " << cellId
+                                 << " mn=" << mn << " mp=" << mp << " offset=" << off
+                                 << " entryCond=" << entryCond
+                                 << " leavingCond=" << leavingCond);
 
-        if (entryCond)
-          {
-            for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
-                 storedMeasIt != m_storedMeasValues.end ();
-                 ++storedMeasIt)
-              {
-                uint16_t cellId = storedMeasIt->first;
-                if (cellId == m_cellId)
-                  {
-                    continue;
-                  }
+            } // end of for (storedMeasIt)
+
+        } // end of case LteRrcSap::ReportConfigEutra::EVENT_A3
+
+        break;
+
+      case LteRrcSap::ReportConfigEutra::EVENT_A4:
+        {
+          /*
+           * Event A4 (Neighbour becomes better than threshold)
+           * Please refer to 3GPP TS 36.331 Section 5.5.4.5
+           */
+
+          double mn; // Mn, the measurement result of the neighbouring cell
+          double ofn = measObjectEutra.offsetFreq; // Ofn, the frequency specific offset of the frequency of the
+          double ocn = 0.0; // Ocn, the cell specific offset of the neighbour cell
+          double thresh; // Thresh, the threshold parameter for this event
+          // Hys, the hysteresis parameter for this event.
+          double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
 
-                switch (reportConfigEutra.triggerQuantity)
-                  {
+          switch (reportConfigEutra.triggerQuantity)
+            {
+              case LteRrcSap::ReportConfigEutra::RSRP:
+                NS_ASSERT (reportConfigEutra.threshold1.choice
+                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
+                thresh = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
+                break;
+              case LteRrcSap::ReportConfigEutra::RSRQ:
+                NS_ASSERT (reportConfigEutra.threshold1.choice
+                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
+                thresh = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
+                break;
+              default:
+                NS_FATAL_ERROR ("unsupported triggerQuantity");
+                break;
+            }
+
+          for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
+               storedMeasIt != m_storedMeasValues.end ();
+               ++storedMeasIt)
+            {
+              uint16_t cellId = storedMeasIt->first;
+              if (cellId == m_cellId)
+                {
+                  continue;
+                }
+
+              switch (reportConfigEutra.triggerQuantity)
+                {
                   case LteRrcSap::ReportConfigEutra::RSRP:
                     mn = storedMeasIt->second.rsrp;
                     break;
